"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_hid_1 = __importDefault(require("node-hid"));
const host_1 = __importDefault(require("../utils/host"));
function report(deviceHash) {
    var _a, _b;
    const { vendorId, productId } = deviceHash.hidDevice;
    const writeBytes = (_a = deviceHash.headphone) === null || _a === void 0 ? void 0 : _a.writeBytes;
    let device;
    const devicePath = (_b = deviceHash.headphone) === null || _b === void 0 ? void 0 : _b.path;
    if (devicePath === undefined) {
        return deviceHash;
    }
    if (host_1.default.isWin()) {
        try {
            device = new node_hid_1.default.HID(devicePath);
        }
        catch (_c) {
            // skip
        }
    }
    try {
        if (device === undefined) {
            device = new node_hid_1.default.HID(vendorId, productId);
        }
    }
    catch (_d) {
        // skip
    }
    let report = [];
    if (device !== undefined) {
        try {
            device.write(writeBytes);
            report = device.readTimeout(100);
        }
        catch (_e) {
            // skip
        }
        finally {
            device.close();
        }
    }
    deviceHash.report = report;
    return deviceHash;
}
exports.default = report;
